__gnu_debug::basic_string< _CharT, _Traits, _Allocator > Class Template Reference
Inheritance diagram for __gnu_debug::basic_string< _CharT, _Traits, _Allocator >:
[legend]

## Public Types

typedef _Allocator | allocator_type
typedef __gnu_debug::_Safe_iterator< typename _Base::const_iterator, basic_string > | const_iterator
typedef _Base::const_pointer | const_pointer
typedef _Base::const_reference | const_reference
typedef std::reverse_iterator< const_iterator > | const_reverse_iterator
typedef _Base::difference_type | difference_type
typedef __gnu_debug::_Safe_iterator< typename _Base::iterator, basic_string > | iterator
typedef _Base::pointer | pointer
typedef _Base::reference | reference
typedef std::reverse_iterator< iterator > | reverse_iterator
typedef _Base::size_type | size_type
typedef _Traits | traits_type
typedef _Traits::char_type | value_type

## Public Member Functions

| basic_string (_Base &&__base) noexcept
template<typename _InputIterator >
| basic_string (_InputIterator __begin, _InputIterator __end, const _Allocator &__a=_Allocator())
| basic_string (basic_string &&)=default
| basic_string (const _Allocator &__a) noexcept
| basic_string (const _Base &__base)
| basic_string (const _CharT *__s, const _Allocator &__a=_Allocator())
| basic_string (const _CharT *__s, size_type __n, const _Allocator &__a=_Allocator())
| basic_string (const basic_string &)=default
| basic_string (const basic_string &__str, size_type __pos, size_type __n=_Base::npos, const _Allocator &__a=_Allocator())
| basic_string (size_type __n, _CharT __c, const _Allocator &__a=_Allocator())
| basic_string (std::initializer_list< _CharT > __l, const _Allocator &__a=_Allocator())
const _Base & | _M_base () const noexcept
_Base & | _M_base () noexcept
void | _M_invalidate_if (_Predicate __pred)
basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | _M_replace_dispatch (iterator __i1, iterator __i2, _InputIterator __k1, _InputIterator __k2, __false_type)
void | _M_swap (_Safe_container &__x) noexcept
void | _M_transfer_from_if (_Safe_sequence &__from, _Predicate __pred)
_CharT * | _S_construct (_InIterator __beg, _InIterator __end, const std::allocator< _CharT > &__a, forward_iterator_tag)
template<typename _InputIterator >
basic_string & | append (_InputIterator __first, _InputIterator __last)
basic_string & | append (const _CharT *__s)
basic_string & | append (const _CharT *__s, size_type __n)
basic_string & | append (const basic_string &__str)
basic_string & | append (const basic_string &__str)
basic_string & | append (const basic_string &__str, size_type __pos, size_type __n)
basic_string & | append (const basic_string &__str, size_type __pos, size_type __n=npos)
basic_string & | append (initializer_list< _CharT > __l)
basic_string & | append (size_type __n, _CharT __c)
template<typename _InputIterator >
basic_string & | assign (_InputIterator __first, _InputIterator __last)
basic_string & | assign (basic_string &&__str)
basic_string & | assign (basic_string &&__x) noexcept(noexcept(std::declval< _Base & >().assign(std::move(__x))))
basic_string & | assign (const _CharT *__s)
basic_string & | assign (const _CharT *__s, size_type __n)
basic_string & | assign (const basic_string &__str)
basic_string & | assign (const basic_string &__str, size_type __pos, size_type __n)
basic_string & | assign (const basic_string &__str, size_type __pos, size_type __n=npos)
basic_string & | assign (const basic_string &__x)
basic_string & | assign (size_type __n, _CharT __c)
basic_string & | assign (std::initializer_list< _CharT > __l)
reference | at (size_type __n)
reference | at (size_type __n)
const_reference | at (size_type __n) const
const_reference | at (size_type __n) const
reference | back ()
const_reference | back () const noexcept
iterator | begin ()
const_iterator | begin () const noexcept
const _CharT * | c_str () const noexcept
const _CharT * | c_str () const noexcept
size_type | capacity () const noexcept
const_iterator | cbegin () const noexcept
const_iterator | cbegin () const noexcept
const_iterator | cend () const noexcept
const_iterator | cend () const noexcept
void | clear ()
int | compare (const _CharT *__s) const
int | compare (const basic_string &__str) const
int | compare (const basic_string &__str) const
int | compare (size_type __pos, size_type __n, const basic_string &__str) const
int | compare (size_type __pos1, size_type __n1, const _CharT *__s) const
int | compare (size_type __pos1, size_type __n1, const _CharT *__s, size_type __n2) const
int | compare (size_type __pos1, size_type __n1, const basic_string &__str) const
int | compare (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2) const
int | compare (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2=npos) const
size_type | copy (_CharT *__s, size_type __n, size_type __pos=0) const
const_reverse_iterator | crbegin () const noexcept
const_reverse_iterator | crbegin () const noexcept
const_reverse_iterator | crend () const noexcept
const_reverse_iterator | crend () const noexcept
const _CharT * | data () const noexcept
const _CharT * | data () const noexcept
bool | empty () const noexcept
iterator | end ()
const_iterator | end () const noexcept
iterator | erase (iterator __first, iterator __last)
iterator | erase (iterator __first, iterator __last)
iterator | erase (iterator __position)
iterator | erase (iterator __position)
basic_string & | erase (size_type __pos=0, size_type __n=_Base::npos)
size_type | find (_CharT __c, size_type __pos=0) const noexcept
size_type | find (const _CharT *__s, size_type __pos, size_type __n) const
size_type | find (const _CharT *__s, size_type __pos=0) const
size_type | find (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find_first_not_of (_CharT __c, size_type __pos=0) const noexcept
size_type | find_first_not_of (const _CharT *__s, size_type __pos, size_type __n) const
size_type | find_first_not_of (const _CharT *__s, size_type __pos=0) const
size_type | find_first_not_of (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find_first_not_of (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find_first_of (_CharT __c, size_type __pos=0) const noexcept
size_type | find_first_of (const _CharT *__s, size_type __pos, size_type __n) const
size_type | find_first_of (const _CharT *__s, size_type __pos=0) const
size_type | find_first_of (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find_first_of (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find_last_not_of (_CharT __c, size_type __pos=_Base::npos) const noexcept
size_type | find_last_not_of (const _CharT *__s, size_type __pos, size_type __n) const
size_type | find_last_not_of (const _CharT *__s, size_type __pos=_Base::npos) const
size_type | find_last_not_of (const basic_string &__str, size_type __pos=_Base::npos) const noexcept
size_type | find_last_not_of (const basic_string &__str, size_type __pos=npos) const noexcept
size_type | find_last_of (_CharT __c, size_type __pos=_Base::npos) const noexcept
size_type | find_last_of (const _CharT *__s, size_type __pos, size_type __n) const
size_type | find_last_of (const _CharT *__s, size_type __pos=_Base::npos) const
size_type | find_last_of (const basic_string &__str, size_type __pos=_Base::npos) const noexcept
size_type | find_last_of (const basic_string &__str, size_type __pos=npos) const noexcept
reference | front ()
const_reference | front () const noexcept
allocator_type | get_allocator () const noexcept
iterator | insert (iterator __p, _CharT __c)
iterator | insert (iterator __p, _CharT __c)
void | insert (iterator __p, _InputIterator __beg, _InputIterator __end)
template<typename _InputIterator >
void | insert (iterator __p, _InputIterator __first, _InputIterator __last)
void | insert (iterator __p, initializer_list< _CharT > __l)
void | insert (iterator __p, size_type __n, _CharT __c)
void | insert (iterator __p, size_type __n, _CharT __c)
void | insert (iterator __p, std::initializer_list< _CharT > __l)
basic_string & | insert (size_type __pos, const _CharT *__s)
basic_string & | insert (size_type __pos, const _CharT *__s, size_type __n)
basic_string & | insert (size_type __pos, size_type __n, _CharT __c)
basic_string & | insert (size_type __pos1, const basic_string &__str)
basic_string & | insert (size_type __pos1, const basic_string &__str)
basic_string & | insert (size_type __pos1, const basic_string &__str, size_type __pos2, size_type __n)
basic_string & | insert (size_type __pos1, const basic_string &__str, size_type __pos2, size_type __n=npos)
size_type | length () const noexcept
size_type | max_size () const noexcept
basic_string & | operator+= (_CharT __c)
basic_string & | operator+= (const _CharT *__s)
basic_string & | operator+= (const basic_string &__str)
basic_string & | operator+= (const basic_string &__str)
basic_string & | operator+= (std::initializer_list< _CharT > __l)
basic_string & | operator= (_CharT __c)
basic_string & | operator= (basic_string &&)=default
basic_string & | operator= (const _CharT *__s)
basic_string & | operator= (const basic_string &)=default
basic_string & | operator= (std::initializer_list< _CharT > __l)
reference | operator[] (size_type __pos)
const_reference | operator[] (size_type __pos) const noexcept
void | pop_back ()
void | push_back (_CharT __c)
reverse_iterator | rbegin ()
const_reverse_iterator | rbegin () const noexcept
reverse_iterator | rend ()
const_reverse_iterator | rend () const noexcept
basic_string & | replace (iterator __i1, iterator __i2, _CharT *__k1, _CharT *__k2)
template<typename _InputIterator >
basic_string & | replace (iterator __i1, iterator __i2, _InputIterator __j1, _InputIterator __j2)
basic_string & | replace (iterator __i1, iterator __i2, _InputIterator __k1, _InputIterator __k2)
basic_string & | replace (iterator __i1, iterator __i2, const _CharT *__k1, const _CharT *__k2)
basic_string & | replace (iterator __i1, iterator __i2, const _CharT *__s)
basic_string & | replace (iterator __i1, iterator __i2, const _CharT *__s)
basic_string & | replace (iterator __i1, iterator __i2, const _CharT *__s, size_type __n)
basic_string & | replace (iterator __i1, iterator __i2, const _CharT *__s, size_type __n)
basic_string & | replace (iterator __i1, iterator __i2, const basic_string &__str)
basic_string & | replace (iterator __i1, iterator __i2, const basic_string &__str)
basic_string & | replace (iterator __i1, iterator __i2, const_iterator __k1, const_iterator __k2)
basic_string & | replace (iterator __i1, iterator __i2, initializer_list< _CharT > __l)
basic_string & | replace (iterator __i1, iterator __i2, iterator __k1, iterator __k2)
basic_string & | replace (iterator __i1, iterator __i2, size_type __n, _CharT __c)
basic_string & | replace (iterator __i1, iterator __i2, size_type __n, _CharT __c)
basic_string & | replace (iterator __i1, iterator __i2, std::initializer_list< _CharT > __l)
basic_string & | replace (size_type __pos, size_type __n, const basic_string &__str)
basic_string & | replace (size_type __pos, size_type __n1, const _CharT *__s)
basic_string & | replace (size_type __pos, size_type __n1, const _CharT *__s, size_type __n2)
basic_string & | replace (size_type __pos, size_type __n1, size_type __n2, _CharT __c)
basic_string & | replace (size_type __pos1, size_type __n1, const basic_string &__str)
basic_string & | replace (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2)
basic_string & | replace (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2=npos)
void | reserve (size_type __res_arg=0)
void | reserve (size_type __res_arg=0)
void | resize (size_type __n)
void | resize (size_type __n, _CharT __c)
size_type | rfind (_CharT __c, size_type __pos=_Base::npos) const noexcept
size_type | rfind (const _CharT *__s, size_type __pos, size_type __n) const
size_type | rfind (const _CharT *__s, size_type __pos=_Base::npos) const
size_type | rfind (const basic_string &__str, size_type __pos=_Base::npos) const noexcept
size_type | rfind (const basic_string &__str, size_type __pos=npos) const noexcept
void | shrink_to_fit () noexcept
size_type | size () const noexcept
basic_string | substr (size_type __pos=0, size_type __n=_Base::npos) const
void | swap (basic_string &__s)
void | swap (basic_string &__x) noexcept(/*conditional */)

## Static Public Attributes

static const size_type | npos

## Protected Member Functions

_Safe_container & | _M_safe () noexcept

## Detailed Description

### template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>
class __gnu_debug::basic_string< _CharT, _Traits, _Allocator >

Class std::basic_string with safety/checking/debug instrumentation.

Definition at line 44 of file debug/string.

## Member Function Documentation

## _M_invalidate_if()

void __gnu_debug::_Safe_sequence< basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > >::_M_invalidate_if | ( | _Predicate | __pred | ) |

inherited

Invalidates all iterators `x` that reference this sequence, are not singular, and for which `__pred(x)` returns `true`. `__pred` will be invoked with the normal iterators nested in the safe ones.

Definition at line 38 of file safe_sequence.tcc.

## _M_transfer_from_if()

void __gnu_debug::_Safe_sequence< basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > >::_M_transfer_from_if | ( | _Safe_sequence< basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > > & | __from,
|  | _Predicate | __pred
| ) |  |

inherited

Transfers all iterators `x` that reference `from` sequence, are not singular, and for which `__pred(x)` returns `true`. `__pred` will be invoked with the normal iterators nested in the safe ones.

Definition at line 69 of file safe_sequence.tcc.

## append() [1/3]

basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > > & std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::append | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str | ) |

inherited

Append a string to this string.

Parameters

  __str | The string to append.

Returns
  Reference to this string.

Definition at line 775 of file basic_string.tcc.

## append() [2/3]

basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > > & std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::append | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos,
|  | size_type | __n = `npos`
| ) |  |

inherited

Append a substring.

Parameters

  __str | The string to append.
  __pos | Index of the first character of str to append.
  __n | The number of characters to append.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | if __pos is not a valid index.

This function appends __n characters from __str starting at __pos to this string. If __n is is larger than the number of available characters in __str, the remainder of __str is appended.

Definition at line 792 of file basic_string.tcc.

## append() [3/3]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::append | ( | initializer_list< _CharT > | __l | ) |

inline inherited

Append an initializer_list of characters.

Parameters

  __l | The initializer_list of characters to append.

Returns
  Reference to this string.

Definition at line 4188 of file basic_string.h.

## assign() [1/3]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::assign | ( | basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > && | __str | ) |

inline inherited

Set value to contents of another string.

Parameters

  __str | Source string to use.

Returns
  Reference to this string.

This function sets this string to the exact contents of __str. __str is a valid, but unspecified string.

Definition at line 4271 of file basic_string.h.

## assign() [2/3]

basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > > & std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::assign | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str | ) |

inherited

Set value to contents of another string.

Parameters

  __str | Source string to use.

Returns
  Reference to this string.

Definition at line 693 of file basic_string.tcc.

## assign() [3/3]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::assign | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos,
|  | size_type | __n = `npos`
| ) |  |

inline inherited

Set value to a substring of a string.

Parameters

  __str | The string to use.
  __pos | Index of the first character of str.
  __n | Number of characters to use.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | if pos is not a valid index.

This function sets this string to the substring of __str consisting of __n characters at __pos. If __n is is larger than the number of available characters in __str, the remainder of __str is used.

Definition at line 4292 of file basic_string.h.

## at() [1/4]

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

reference std::basic_string< _CharT, _Traits, _Alloc >::at

inline

Provides access to the data contained in the string.

Parameters

  __n | The index of the character to access.

Returns
  Read/write reference to the character.

Exceptions

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails. Success results in unsharing the string.

Definition at line 4014 of file basic_string.h.

## at() [2/4]

reference std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::at | ( | size_type | __n | ) |

inline inherited

Provides access to the data contained in the string.

Parameters

  __n | The index of the character to access.

Returns
  Read/write reference to the character.

Exceptions

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails. Success results in unsharing the string.

Definition at line 4014 of file basic_string.h.

## at() [3/4]

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_reference std::basic_string< _CharT, _Traits, _Alloc >::at

inline

Provides access to the data contained in the string.

Parameters

  __n | The index of the character to access.

Returns
  Read-only (const) reference to the character.

Exceptions

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails.

Definition at line 3992 of file basic_string.h.

## at() [4/4]

const_reference std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::at | ( | size_type | __n | ) | const

inline inherited

Provides access to the data contained in the string.

Parameters

  __n | The index of the character to access.

Returns
  Read-only (const) reference to the character.

Exceptions

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails.

Definition at line 3992 of file basic_string.h.

## back() [1/2]

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

reference std::basic_string< _CharT, _Traits, _Alloc >::back

inline

Returns a read/write reference to the data at the last element of the string.

Definition at line 4053 of file basic_string.h.

## back() [2/2]

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_reference std::basic_string< _CharT, _Traits, _Alloc >::back

inline noexcept

Returns a read-only (constant) reference to the data at the last element of the string.

Definition at line 4064 of file basic_string.h.

## c_str()

const _CharT* std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::c_str

inline noexcept inherited

Return const pointer to null-terminated contents.

This is a handle to internal data. Do not modify or dire things may happen.

Definition at line 5118 of file basic_string.h.

## capacity()

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Alloc >::capacity

inline noexcept

Returns the total number of characters that the string can hold before needing to allocate more memory.

Definition at line 3888 of file basic_string.h.

## cbegin()

const_iterator std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::cbegin

inline noexcept inherited

Returns a read-only (constant) iterator that points to the first character in the string.

Definition at line 3790 of file basic_string.h.

## cend()

const_iterator std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::cend

inline noexcept inherited

Returns a read-only (constant) iterator that points one past the last character in the string.

Definition at line 3798 of file basic_string.h.

## compare() [1/3]

int std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::compare | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str | ) | const

inline inherited

Compare to a string.

Parameters

  __str | String to compare against.

Returns
  Integer < 0, 0, or > 0.

Returns an integer < 0 if this string is ordered before __str, 0 if their values are equivalent, or > 0 if this string is ordered after __str. Determines the effective length rlen of the strings to compare as the smallest of size() and str.size(). The function then compares the two strings by calling traits::compare(data(), str.data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 5674 of file basic_string.h.

## compare() [2/3]

int std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::compare | ( | size_type | __pos,
|  | size_type | __n,
|  | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str
| ) |  | const

inherited

Compare substring to a string.

Parameters

  __pos | Index of first character of substring.
  __n | Number of characters in substring.
  __str | String to compare against.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n characters starting at __pos. Returns an integer < 0 if the substring is ordered before __str, 0 if their values are equivalent, or > 0 if the substring is ordered after __str. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and __str.size(). The function then compares the two strings by calling traits::compare(substring.data(),str.data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 1385 of file basic_string.tcc.

## compare() [3/3]

int std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::compare | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos2,
|  | size_type | __n2 = `npos`
| ) |  | const

inherited

Compare substring to a substring.

Parameters

  __pos1 | Index of first character of substring.
  __n1 | Number of characters in substring.
  __str | String to compare against.
  __pos2 | Index of first character of substring of str.
  __n2 | Number of characters in substring of str.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n1 characters starting at __pos1. Form the substring of __str from the __n2 characters starting at __pos2. Returns an integer < 0 if this substring is ordered before the substring of __str, 0 if their values are equivalent, or > 0 if this substring is ordered after the substring of __str. Determines the effective length rlen of the strings to compare as the smallest of the lengths of the substrings. The function then compares the two strings by calling traits::compare(substring.data(),str.substr(pos2,n2).data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 1400 of file basic_string.tcc.

## crbegin()

const_reverse_iterator std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::crbegin

inline noexcept inherited

Returns a read-only (constant) reverse iterator that points to the last character in the string. Iteration is done in reverse element order.

Definition at line 3807 of file basic_string.h.

## crend()

const_reverse_iterator std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::crend

inline noexcept inherited

Returns a read-only (constant) reverse iterator that points to one before the first character in the string. Iteration is done in reverse element order.

Definition at line 3816 of file basic_string.h.

## data()

const _CharT* std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::data

inline noexcept inherited

Return const pointer to contents.

This is a pointer to internal data. It is undefined to modify the contents through the returned pointer. To get a pointer that allows modifying the contents use `&str`[0] instead, (or in C++17 the non-const `str.data()` overload).

Definition at line 5130 of file basic_string.h.

## empty()

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

bool std::basic_string< _CharT, _Traits, _Alloc >::empty

inline noexcept

Returns true if the string is empty. Equivalent to `*this == ""`.

Definition at line 3938 of file basic_string.h.

## erase() [1/2]

basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::iterator std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::erase | ( | iterator | __first,
|  | iterator | __last
| ) |  |

inherited

Remove a range of characters.

Parameters

  __first | Iterator referencing the first character to remove.
  __last | Iterator referencing the end of the range.

Returns
  Iterator referencing location of first after removal.

Removes the characters in the range [first,last) from this string. The value of the string doesn't change if an error is thrown.

Definition at line 841 of file basic_string.tcc.

## erase() [2/2]

iterator std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::erase | ( | iterator | __position | ) |

inline inherited

Remove one character.

Parameters

  __position | Iterator referencing the character to remove.

Returns
  iterator referencing same location after removal.

Removes the character at __position from this string. The value of the string doesn't change if an error is thrown.

Definition at line 4638 of file basic_string.h.

## find()

size_type std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::find | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos = `0`
| ) |  | const

inline noexcept inherited

Find position of a string.

Parameters

  __str | String to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of start of first occurrence.

Starting from __pos, searches forward for value of __str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 5182 of file basic_string.h.

## find_first_not_of()

size_type std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::find_first_not_of | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos = `0`
| ) |  | const

inline noexcept inherited

Find position of a character not in string.

Parameters

  __str | String containing characters to avoid.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character not contained in __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 5490 of file basic_string.h.

## find_first_of()

size_type std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::find_first_of | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos = `0`
| ) |  | const

inline noexcept inherited

Find position of a character of string.

Parameters

  __str | String containing characters to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for one of the characters of __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 5323 of file basic_string.h.

## find_last_not_of()

size_type std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::find_last_not_of | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos = `npos`
| ) |  | const

inline noexcept inherited

Find last position of a character not in string.

Parameters

  __str | String containing characters to avoid.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character not contained in __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 5572 of file basic_string.h.

## find_last_of()

size_type std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::find_last_of | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos = `npos`
| ) |  | const

inline noexcept inherited

Find last position of a character of string.

Parameters

  __str | String containing characters to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for one of the characters of __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 5407 of file basic_string.h.

## front() [1/2]

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

reference std::basic_string< _CharT, _Traits, _Alloc >::front

inline

Returns a read/write reference to the data at the first element of the string.

Definition at line 4031 of file basic_string.h.

## front() [2/2]

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_reference std::basic_string< _CharT, _Traits, _Alloc >::front

inline noexcept

Returns a read-only (constant) reference to the data at the first element of the string.

Definition at line 4042 of file basic_string.h.

## get_allocator()

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

allocator_type std::basic_string< _CharT, _Traits, _Alloc >::get_allocator

inline noexcept

Return copy of allocator used to construct this string.

Definition at line 5152 of file basic_string.h.

## insert() [1/6]

iterator std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::insert | ( | iterator | __p,
|  | _CharT | __c
| ) |  |

inline inherited

Insert one character.

Parameters

  __p | Iterator referencing position in string to insert at.
  __c | The character to insert.

Returns
  Iterator referencing newly inserted char.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts character __c at position referenced by __p. If adding character causes the length to exceed max_size(), length_error is thrown. If __p is beyond end of string, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 4561 of file basic_string.h.

## insert() [2/6]

void std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::insert | ( | iterator | __p,
|  | _InputIterator | __beg,
|  | _InputIterator | __end
| ) |  |

inline inherited

Insert a range of characters.

Parameters

  __p | Iterator referencing location in string to insert at.
  __beg | Start of range.
  __end | End of range.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts characters in range [__beg,__end). If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 4426 of file basic_string.h.

## insert() [3/6]

void std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::insert | ( | iterator | __p,
|  | initializer_list< _CharT > | __l
| ) |  |

inline inherited

Insert an initializer_list of characters.

Parameters

  __p | Iterator referencing location in string to insert at.
  __l | The initializer_list of characters to insert.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Definition at line 4437 of file basic_string.h.

## insert() [4/6]

void std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::insert | ( | iterator | __p,
|  | size_type | __n,
|  | _CharT | __c
| ) |  |

inline inherited

Insert multiple characters.

Parameters

  __p | Iterator referencing location in string to insert at.
  __n | Number of characters to insert
  __c | The character to insert.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts __n copies of character __c starting at the position referenced by iterator __p. If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 4409 of file basic_string.h.

## insert() [5/6]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::insert | ( | size_type | __pos1,
|  | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str
| ) |  |

inline inherited

Insert value of a string.

Parameters

  __pos1 | Iterator referencing location in string to insert at.
  __str | The string to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts value of __str starting at __pos1. If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 4457 of file basic_string.h.

## insert() [6/6]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::insert | ( | size_type | __pos1,
|  | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos2,
|  | size_type | __n = `npos`
| ) |  |

inline inherited

Insert a substring.

Parameters

  __pos1 | Iterator referencing location in string to insert at.
  __str | The string to insert.
  __pos2 | Start of characters in str to insert.
  __n | Number of characters to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.
  std::out_of_range | If pos1 > size() or __pos2 > str.size().

Starting at pos1, insert __n character of __str beginning with __pos2. If adding characters causes the length to exceed max_size(), length_error is thrown. If __pos1 is beyond the end of this string or __pos2 is beyond the end of __str, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 4479 of file basic_string.h.

## length()

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Alloc >::length

inline noexcept

Returns the number of characters in the string, not including any null-termination.

Definition at line 3831 of file basic_string.h.

## max_size()

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Alloc >::max_size

inline noexcept

Returns the size() of the largest possible string.

Definition at line 3836 of file basic_string.h.

## operator+=()

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::operator+= | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str | ) |

inline inherited

Append a string to this string.

Parameters

  __str | The string to append.

Returns
  Reference to this string.

Definition at line 4078 of file basic_string.h.

## replace() [1/8]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | _InputIterator | __k1,
|  | _InputIterator | __k2
| ) |  |

inline inherited

Replace range of characters with range.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __k1 | Iterator referencing start of range to insert.
  __k2 | Iterator referencing end of range to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, characters in the range [__k1,__k2) are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 4886 of file basic_string.h.

## replace() [2/8]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const _CharT * | __s
| ) |  |

inline inherited

Replace range of characters with C string.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __s | C string value to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, the characters of __s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 4841 of file basic_string.h.

## replace() [3/8]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const _CharT * | __s,
|  | size_type | __n
| ) |  |

inline inherited

Replace range of characters with C substring.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __s | C string value to insert.
  __n | Number of characters from s to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, the first __n characters of __s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 4820 of file basic_string.h.

## replace() [4/8]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str
| ) |  |

inline inherited

Replace range of characters with string.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __str | String value to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, the value of __str is inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 4801 of file basic_string.h.

## replace() [5/8]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | initializer_list< _CharT > | __l
| ) |  |

inline inherited

Replace range of characters with initializer_list.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __l | The initializer_list of characters to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, characters in the range [__k1,__k2) are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 4955 of file basic_string.h.

## replace() [6/8]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | size_type | __n,
|  | _CharT | __c
| ) |  |

inline inherited

Replace range of characters with multiple characters.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __n | Number of characters to insert.
  __c | Character to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, __n copies of __c are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 4862 of file basic_string.h.

## replace() [7/8]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::replace | ( | size_type | __pos,
|  | size_type | __n,
|  | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str
| ) |  |

inline inherited

Replace characters with value from another string.

Parameters

  __pos | Index of first character to replace.
  __n | Number of characters to be replaced.
  __str | String to insert.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If pos is beyond the end of this string.
  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__pos,__pos+__n) from this string. In place, the value of __str is inserted. If __pos is beyond end of string, out_of_range is thrown. If the length of the result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 4692 of file basic_string.h.

## replace() [8/8]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::replace | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos2,
|  | size_type | __n2 = `npos`
| ) |  |

inline inherited

Replace characters with value from another string.

Parameters

  __pos1 | Index of first character to replace.
  __n1 | Number of characters to be replaced.
  __str | String to insert.
  __pos2 | Index of first character of str to use.
  __n2 | Number of characters from str to use.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If __pos1 > size() or __pos2 > __str.size().
  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__pos1,__pos1 + n) from this string. In place, the value of __str is inserted. If __pos is beyond end of string, out_of_range is thrown. If the length of the result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 4714 of file basic_string.h.

## reserve() [1/2]

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

void std::basic_string< _CharT, _Traits, _Alloc >::reserve

Attempt to preallocate enough memory for specified number of characters.

Parameters

  __res_arg | Number of characters required.

Exceptions

  std::length_error | If __res_arg exceeds `max_size()`.

This function attempts to reserve enough memory for the string to hold the specified number of characters. If the number requested is more than max_size(), length_error is thrown.

The advantage of this function is that if optimal code is a necessity and the user can determine the string length that will be required, the user can reserve the memory in advance, and thus prevent a possible reallocation of memory and copying of string data.

Definition at line 952 of file basic_string.tcc.

## reserve() [2/2]

void std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::reserve | ( | size_type | __res_arg = `0` | ) |

inherited

Attempt to preallocate enough memory for specified number of characters.

Parameters

  __res_arg | Number of characters required.

Exceptions

  std::length_error | If __res_arg exceeds `max_size()`.

This function attempts to reserve enough memory for the string to hold the specified number of characters. If the number requested is more than max_size(), length_error is thrown.

The advantage of this function is that if optimal code is a necessity and the user can determine the string length that will be required, the user can reserve the memory in advance, and thus prevent a possible reallocation of memory and copying of string data.

Definition at line 952 of file basic_string.tcc.

## rfind()

size_type std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::rfind | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos = `npos`
| ) |  | const

inline noexcept inherited

Find last position of a string.

Parameters

  __str | String to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of start of last occurrence.

Starting from __pos, searches backward for value of __str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 5244 of file basic_string.h.

## size()

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Alloc >::size

inline noexcept

Returns the number of characters in the string, not including any null-termination.

Definition at line 3825 of file basic_string.h.

## swap()

void std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::swap | ( | basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __s | ) |

inherited

Swap contents with another string.

Parameters

  __s | String to swap with.

Exchanges the contents of this string with that of __s in constant time.

Definition at line 969 of file basic_string.tcc.

## Member Data Documentation

## npos

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::npos

static

Value returned by various member functions when they fail.

Definition at line 3296 of file basic_string.h.

The documentation for this class was generated from the following file:

- debug/string